import QtQuick 2.4

Item {
  // surface textures
  property variant texList0: [
    "bokeh_housus.png",           // 0
    "DrWhite.png",                // 1
    "dark_stoney2.png",           // 2
    "aliencircuit2.jpg",          // 3
    "meteor.png",                 // 4
    "asb2.png",                   // 5
    "asb.png",                    // 6
    "mettex_microscope.png",      // 7
    "orghish.png",                // 8
    "metsgrower.png",						// 9
    "watercolorsplatter.png",		// 10
    "suhha.png",					// 11
    "suhhb.png",					// 12
    "suhh9.png",					// 13
    "merkk5.png",					// 14
    "kivitex1s.png",					// 15
    "naarmui3.png", // 16
    "naarmui4.png", // 17
    "naarmui6.png", // 18
    "foliopossu3.png", // 19
    "alltheleds.png", // 20
    "merkk2.png",					// 21
    "merkk3.png",					// 22
    "merkk4.png",					// 23
    "height/MicroErosion.png", // 24
    "Vally/VallyC.png", // 25
    "Vally/VallyH.png", // 26
    "Vally/VallyN.png", // 27
  ]

  // render target textures created from QML scripts
  property variant texList1: [
    "prev",           // 1000
    "prevBlur",       // 1001
    "prevFin",       // 1002
    "blurGlow", // 1002
    "mesherVertPos", // 1003
    "mesherTriNorm", // 1004
    "mesherVertNorm", // 1005
    "pardexPrefixPrev", // 1006
    "pardexTransmittance", // 1007
    "lightView", // 1008
    "velBuf", // 1009
    "velBufBlur", // 1010
    "worldPos", // 1011
    "worldPosBlur", // 1012
    "pardexMask", // 1013
    "pardexMeshDepth", // 1014
    "pardexMeshWorld", // 1015
    "pardexAge", // 1016
    "pardexPos", // 1017
    "emitCamRGB", // 1018
    "emitCamRGB_depth", // 1019
    "emitBuf", // 1020

    // debukki begin


    //    "meshTexVP_0_mesh/cave.obj", // debukki
    //    "meshTexVUV_0_mesh/cave.obj", // debukki
        "meshTexVP_0_mesh/adaptlogo.obj", // debukki
        "meshTexVUV_0_mesh/adaptlogo.obj", // debukki
        "meshTexVN_0_mesh/adaptlogo.obj", // debukki
        "meshTexVP_0_mesh/numpers3_tri.dae", // debukki
        "meshTexVP_2_mesh/numpers3_tri.dae", // debukki
        "meshTexVPF_0_mesh/numpers3_tri.dae", // debukki
        "meshTexVPF_1_mesh/numpers3_tri.dae", // debukki
        "meshTexFI_0_mesh/numpers3_tri.dae", // debukki
        "meshTexFI_1_mesh/numpers3_tri.dae", // debukki
        "meshTexFI_2_mesh/numpers3_tri.dae", // debukki
        "meshTexFI_0_mesh/spikecube1.obj", // debukki
  ]

  // palette textures
  property variant texList2: [
    "palette/palette_shot1.png",          // 2000
    "palette/palette_shotr.png",          // 2001
    "palette/palette_shot_vapor2.png",    // 2002
    "palette/aita.png",                   // 2003
    "palette/fade1.png",                  // 2004
    "palette/fade2.png",                  // 2005
    "palette/fade3.png",                  // 2006
    "palette/fade4.png",                  // 2007
    "palette/fade5.png",                  // 2008
    "palette/fade6.png",                  // 2009
    "palette/fade7.png",                  // 2010
    "palette/fade_0.png",                 // 2011
    "palette/fade_1.png",                 // 2012
    "palette/fade_2.png",                 // 2013
    "palette/fade_3.png",                 // 2014
    "palette/fade_4.png",                 // 2015
    "palette/Untitled-4.png",             // 2016
    "palette/Untitled-22.png",            // 2017
    "palette/Untitled-23.png",            // 2018
    "palette/Untitled-24.png",            // 2019
    "palette/Untitled-47.png",            // 2020
    "palette/RGBpohja2.png",              // 2021
    "palette/RGBpohja5.png",              // 2022
    "palette/Tones_1.png",                // 2023
    "palette/Tones_2.png",                // 2024
    "palette/Tones_3.png",                // 2025
    "palette/Tones_4.png",                // 2026
    "palette/Tones_5.png",                // 2027
    "palette/Tones_6.png",                // 2028
    "palette/Tones_7.png",                // 2029
    "palette/Tones_8.png",                // 2030
    "palette/Tones_8bit.png",             // 2031
    "palette/Tones_9.png",                // 2032
    "palette/spectr_logoon.png",          // 2024
  ]

  // partikle textures
  property variant texList3: [
    "part/bokeh3_256.png",             // 3000
    "part/bokeh3_512.png",             // 3001
    "part/bokeh4.png",                 // 3002
    "part/bokeh3_2048.png",            // 3003
    "part/ballero4.png",            // 3004
    "part/ballero2.png",            // 3005
    "part/rotblurrer6.png",         // 3006
  ]

  // overlay textures
  property variant texList4: [
    "ovl/adapt.png",                 // 4000
    "ovl/adaptp.png",                // 4001
    "ovl/adapt2.png",                // 4002
    "ovl/minds2.png",                // 4003
    "",                              // 4004
    "",                              // 4005
    "ovl/ovl_crediz.png",            // 4006
    "ovl/greets5.png",               // 4007
    "",                              // 4008
    "",                              // 4009
    "",                              // 4010
    "system/loader.png",		         // 4011
    "",                              // 4012
    "ovl/FieldCircle_A.png",         // 4013
    "ovl/FieldCircle_B.png",         // 4014
    "ovl/FieldCircle_C.png",         // 4015
    "ovl/wad1.png",                  // 4016
    "ovl/tellys.png",				         // 4017
    "ovl/tellyy.png",					       // 4018
    "",					      				       // 4019
    "ovl/tresh3.png",					       // 4020
    "ovl/tresh6.png",					       // 4021
  ]

  // sprite anim textures
  property variant texList5: [
    "",             // 5000 - X frames per row, Y rows, total Z
  ]

}
