import QtQuick 2.3
import "../" // to import RocketScene
import "../_SharedQML"
import AdaptDemoSystem 1.0

Group {
    id: coords
    property string name: "coords"
    effectName: "Coords"
    enabled: syncRoot(name+".ON")

    Shader { file: "smCoords" }
    TextureImage {
        textureUnit: 0
        file: "../../images/system/G16grid2.png"
    }
    DrawMesh {
        //Clear { cR: 0.0; cG: 0.0; cB: 0.0 }
        property string name: "mesh2"
        file: "mesh/XYZ.lwo"
        Pos { x: 0.0; y: 0.0; z: 0.0; }
        //        Rot { d: -90.0; ax: 0.0; ay: 1.0; az: 0.0 }
        Sca { s: 10.0; x: 1.0; y: 1.0; z: -1.0 }
        autoCenter: false
        autoScale: false

        ShaderParam {
            paramName: "g_uvScale"; paramValue: 1.00
        }
        ShaderParam {
            paramName: "g_texBrightness"; paramValue: 3.00
        }

        blendMode: "add"
        depthTest: false
        depthWrite: false

    }
    DrawMesh {
        //Clear { cR: 0.0; cG: 0.0; cB: 0.0 }
        property string name: "mesh2"
        file: "mesh/RulerPlane16x16.lwo"
       // file: "mesh/XYZ.lwo"
        Pos { x: 0.0; y: 0.0; z: 0.0; }
        //        Rot { d: -90.0; ax: 0.0; ay: 1.0; az: 0.0 }
        Sca { s: 5.0; x: 1.0; y: 1.0; z: 1.0 }
        autoCenter: false
        autoScale: false

        ShaderParam {
            paramName: "g_uvScale"; paramValue: 1.00
        }
        ShaderParam {
            paramName: "g_texBrightness"; paramValue: 1.00
        }

        blendMode: "add"
        depthTest: false
        depthWrite: false
    }

    DrawMesh {
        //Clear { cR: 0.0; cG: 0.0; cB: 0.0 }
        property string name: "mesh2"
        file: "mesh/ball5000.x"
        Pos { x: 1.0; y: 0.0; z: 1.0; }
        //        Rot { d: -90.0; ax: 0.0; ay: 1.0; az: 0.0 }
        Sca { s: 0.50; x: 1.0; y: 1.0; z: 1.0 }
        autoCenter: false
        autoScale: false

        ShaderParam {
            paramName: "g_uvScale"; paramValue: 1.00
        }
        ShaderParam {
            paramName: "g_texBrightness"; paramValue: 3.00
        }

        blendMode: "add"
        depthTest: false
        depthWrite: false

    }
}

