#version 430

layout (location=0) in vec3 vertexPosition;
layout (location=1) in vec2 vertexUV;
layout (location=2) in vec3 vel;
layout (location=3) in vec3 col;
layout (location=4) in float age;
layout (location=5) in float rec;
layout (location=6) in float ageSplit;
layout (location=7) in vec4 params;
//layout (location=7) in vec4 posInit;
// layout (location=7) in vec4 posScr;

out vec3 posV;
out vec2 uvV;
out vec3 velV;
out vec3 colV;
out float ageV;
out float recV;
out vec4 paramsV;
// out vec4 posScrV;

uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;
uniform float g_time;

uniform float g_scale;

void main() {
  posV = vertexPosition.xyz*g_scale;
  //gl_Position.x += gl_VertexID;
  uvV = vertexUV;
  velV = vel;
  colV = col;
  ageV = age;
  recV = rec;
  paramsV = params;
 // posInitV = posInit;
 // posScrV = posScr;
}
