#version 430


in vec3 posV[];
in vec2 uvV[];
in vec3 velV[];
in float ageV[];
in float recV[];
in vec4 posInitV[];
in float ageSplitV[];
// in vec4 posScrV[];

out vec4 posG;
out vec2 uvG;
out vec2 uvOrig;
out float sharpnessG;
out vec4 posSS;
out float age;
out float ageSplit;

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}
vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}
vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXY3(vec3 p, float a) {
  return rotateXY(vec4(p, 0.0), a).xyz;
}
vec3 rotateYZ3(vec3 p, float a) {
  return rotateYZ(vec4(p, 0.0), a).xyz;
}
vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}


layout(points) in;
layout(triangle_strip, max_vertices = 4) out;
//layout(line_strip, max_vertices = 15) out;


layout(binding=0, offset=0) uniform atomic_uint ac;

 
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform float g_time;

uniform float windowWidth = 1280.0;
uniform float windowHeight = 720.0;

layout(binding=0) uniform sampler2D tex;
layout(binding=2) uniform sampler2D texEmit;

uniform float g_pikselos = 0.0;

uniform float g_partSize = 0.15;

uniform float g_alkuRotate = 0.0;
uniform float g_rotateSpeed = 0.0;


float atanSafe(float y, float x) {
 float ret=0.0;
        if (x!=0.0) {
                if (x>0.0) {
                        ret=atan(y/x);
                } else	{
                        ret=atan(y/x)+3.141592;
                }
        } else {
                if (y>=0.0) {
                        ret=0.5*3.141592;
                } else {
                        ret=-0.5*3.141592;
                }
        }
 return ret;
}

void main(void) {
    if (gl_in.length()<1) {
        return;
    }

    if (gl_in.length()>1) {
        return;
    }

    if (recV[0] < 0.5) {
        return;
    }

    vec4 pW = posInitV[0];

    vec2 scrTexPos = pW.xy/pW.w*0.5+vec2(0.5, 0.5);
    if (!(scrTexPos.x>=0.0 && scrTexPos.y>=0.0 && scrTexPos.x<1.0 && scrTexPos.y<1.0)) {
        return;
    }


    mat4 mvp = projectionMatrix * modelViewMatrix;
    vec4 pos = vec4(posV[0], 1.0);
    pos.y -= 0.15;
    pW = mvp*pos;

//    //pos.x = 1.0;
//    //pos.y = 1.0;

//  //  pos = posInitV[0];
   // pos.w = 1.0;


    // vec4 posO = modelViewMatrix*pos;


    vec2 munUv = uvV[0];
    vec4 result = texture2D(texEmit, munUv+vec2(0.0, 0.0));
//    if (result.r < 0.00) {
//        return;
//    }

    int primID = gl_PrimitiveIDIn;

    //float dofSharpArea = 1.0;
    //float dofStrength = 32.0;
    // float sharpness = clamp(10.0-clamp(abs(pos.z*0.007*dofStrength)-dofSharpArea, 0.0, 100000.0), 0.50, 4.0);

    //sharpness = .0;

    gl_PrimitiveID = gl_PrimitiveIDIn;
//    float primId = gl_PrimitiveID;

    //float sharpnessComp = clamp(sharpness, 0.50, 2.0);
    //float pSize = (1.0+clamp(recV[0].x*3.0, 0.0, 6.0)+0.0)*0.01*g_partSize*(1.0+1.0*pow(sharpnessComp, 0.01)); // *(0.50+0.2*sin(primID));
    float pSize = 0.02*g_partSize;

    float partor = (0.83+0.10*sin(gl_PrimitiveIDIn*0.1+0.0*g_time));
   // pSize *= pow(partor, 4.0)*2.0+0.2;

    pSize *= 1.0/(clamp((recV[0]-1.0)*4.0-0.0, 1.0, 1000.0)+1.0);


   // pSize *= (result.r);


// float veny = 0.0;
    float veny = clamp(sqrt(dot(velV[0],velV[0])), 0.0, 0.0);
    float sizeX = pSize*(1.0+veny); // /posO.z; // 100.0/windowWidth;
    float sizeY = pSize*(1.0/(1.0+2.0*veny)); // /posO.z; // 100.0/windowHeight;


    //sharpnessG = sharpness;
    sharpnessG = 1.0;

    float rotAngle = 0.0*atanSafe(velV[0].y,velV[0].x)+0.0*3.141592; // 2.9 + gl_PrimitiveID*0.15+3.0*(1.0+0.5*sin(gl_PrimitiveID*0.1+g_time*0.02));

    rotAngle = ageSplitV[0]*3.14*2.0*g_alkuRotate+g_rotateSpeed*g_time*g_alkuRotate;

    float ar = 9.0/16.0;

    vec4 k;

    //uint counter = atomicCounterIncrement(ac);
//frag.rgb = vec3(fract(float(counter)/(1280.0*720.0)));

    age = ageV[0];

    ageSplit = ageSplitV[0];

    k = rotateXY(vec4(-sizeX, -sizeY, 0.0, 0.0), rotAngle);
    gl_Position = pW+vec4(k.x*ar, k.y, 0.0, 0.0);
    //gl_Position = mvp*pos+vec4(-sizeX*ar, -sizeY, 0.0, 0.0);
    posG = gl_Position;
   // uvG = uv[0];
    uvG = vec2(0.0, 0.0);
    uvOrig = uvV[0];
    posSS = posInitV[0];
    EmitVertex();

    k = rotateXY(vec4(sizeX, -sizeY, 0.0, 0.0), rotAngle);
    gl_Position = pW+vec4(k.x*ar, k.y, 0.0, 0.0);
    //gl_Position = mvp*pos+vec4(sizeX*ar, -sizeY, 0.0, 0.0);
  //  posG = gl_Position;
   // uvG = uv[0];
   // uvOrig = uvV[0];
    uvG = vec2(1.0, 0.0);
    EmitVertex();

    k = rotateXY(vec4(-sizeX, sizeY, 0.0, 0.0), rotAngle);
    gl_Position = pW+vec4(k.x*ar, k.y, 0.0, 0.0);
    //gl_Position = mvp*pos+vec4(-sizeX*ar, sizeY, 0.0, 0.0);
  //  posG = gl_Position;
   // uvG = uv[0];
   // uvOrig = uvV[0];
    uvG = vec2(0.0, 1.0);
    EmitVertex();

    k = rotateXY(vec4(sizeX, sizeY, 0.0, 0.0), rotAngle);
    gl_Position = pW+vec4(k.x*ar, k.y, 0.0, 0.0);
    //gl_Position = mvp*pos+vec4(sizeX*ar, sizeY, 0.0, 0.0);
//    posG = gl_Position;
   // uvOrig = uvV[0];
    uvG = vec2(1.0, 1.0);
    EmitVertex();

    EndPrimitive();

}
