import QtQuick 2.3
import AdaptDemoSystem 1.0

import "demoMock"

GroupBase {
  id: effect
  name: "mesh"
  effectName: "Mesh"
  property bool enabledIn: true
  enabled: syncRootOn(effect.name, effectName) && enabledIn;

  property string reDrawGroups: "shadow,emitter"

  property var syncIn: undefined
  property var syncFFTIn: undefined
  property var depthTestIn: undefined
  property var depthWriteIn: undefined
  property bool setShader: true
  property var fixedTimeStepIn: undefined

  property MeshImpl impl: undefined

  Component {
    id: ec
    MeshImpl {}
  }

  property bool effectExists: false
  onEnabledChanged: {
    if (!enabled && effectExists) {
      effectExists = false;
      impl.destroy(0);
      //log("mesh removed:"+effect.name)
      impl = undefined;
    }
  }

  Connections {
    target: demo
    onFrameRendered: {
      if (effect.enabled && !effectExists) {
        effectExists = true;
        var effectSettings = {
          name: effect.name,
          effectName: effect.effectName,
          reDrawGroups: effect.reDrawGroups,
          setShader: effect.setShader
          // meshParams: effect.meshParams
        };
        if (syncIn !== undefined) {
          effectSettings.syncIn = effect.syncIn;
        }
        if (syncFFTIn !== undefined) {
          effectSettings.syncFFTIn = effect.syncFFTIn;
        }
        if (depthTestIn !== undefined) {
          effectSettings.depthTestIn = effect.depthTestIn;
        }
        if (depthWriteIn !== undefined) {
          effectSettings.depthWriteIn = effect.depthWriteIn;
        }
        if (fixedTimeStepIn !== undefined) {
          effectSettings.fixedTimeStepIn = effect.fixedTimeStepIn
        }
        //    log("created mesh:"+effect.name)
        effect.impl = ec.createObject(effect, effectSettings);
      }
    }
  }

}
